import { QuickJSContext } from "./context";
import { ModuleEvalOptions, QuickJSWASMModule } from "./module";
import { QuickJSRuntime } from "./runtime";
import { ContextOptions, RuntimeOptions } from "./types";
/**
 * A test wrapper of QuickJSWASMModule that keeps a reference to each context or
 * runtime created.
 *
 * Call [[disposeAll]] to reset these sets and calls `dispose` on any left alive
 * (which may throw an error).
 */
export declare class TestQuickJSWASMModule implements Pick<QuickJSWASMModule, keyof QuickJSWASMModule> {
    private parent;
    contexts: Set<QuickJSContext>;
    runtimes: Set<QuickJSRuntime>;
    constructor(parent: QuickJSWASMModule);
    newRuntime(options?: RuntimeOptions): QuickJSRuntime;
    newContext(options?: ContextOptions): QuickJSContext;
    evalCode(code: string, options?: ModuleEvalOptions): unknown;
    disposeAll(): void;
}
