"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.evalOptionsToFlags = exports.DefaultIntrinsics = void 0;
const ffi_types_1 = require("./ffi-types");
const UnstableSymbol = Symbol("Unstable");
// For informational purposes
const DefaultIntrinsicsList = [
    "BaseObjects",
    "Date",
    "Eval",
    "StringNormalize",
    "RegExp",
    "JSON",
    "Proxy",
    "MapSet",
    "TypedArrays",
    "Promise",
];
/**
 * Work in progress.
 */
exports.DefaultIntrinsics = Symbol("DefaultIntrinsics");
/** Convert [[ContextEvalOptions]] to a bitfield flags */
function evalOptionsToFlags(evalOptions) {
    if (typeof evalOptions === "number") {
        return evalOptions;
    }
    if (evalOptions === undefined) {
        return 0;
    }
    const { type, strict, strip, compileOnly, backtraceBarrier } = evalOptions;
    let flags = 0;
    if (type === "global")
        flags |= ffi_types_1.EvalFlags.JS_EVAL_TYPE_GLOBAL;
    if (type === "module")
        flags |= ffi_types_1.EvalFlags.JS_EVAL_TYPE_MODULE;
    if (strict)
        flags |= ffi_types_1.EvalFlags.JS_EVAL_FLAG_STRICT;
    if (strip)
        flags |= ffi_types_1.EvalFlags.JS_EVAL_FLAG_STRIP;
    if (compileOnly)
        flags |= ffi_types_1.EvalFlags.JS_EVAL_FLAG_COMPILE_ONLY;
    if (backtraceBarrier)
        flags |= ffi_types_1.EvalFlags.JS_EVAL_FLAG_BACKTRACE_BARRIER;
    return flags;
}
exports.evalOptionsToFlags = evalOptionsToFlags;
//# sourceMappingURL=types.js.map